#ifdef MATLAB
#include "mex.h"
#endif

#include <math.h>

#include "libm3ddyn.h"
#include "sdlib.h"


//void find_step2_state(double *x0, double *ps, double L, double dx, double dy, double W, double t, double *x){	
//	double w = sqrt(9.81/L);
//	double w2 = w*w;
//	double ddx;
//	double x1[2];
//	double d,dx2,dy2;
//	int dir;
//	double theta = atan2(x0[1]-ps[1] + x0[3]/w,x0[0]-ps[0] + x0[2]/w);
//	double tc[1];
//    
//    //printf("theta = % f\n",theta);
//
//	d = sqrt(dx*dx+dy*dy);
//
//	dx2 = d*cos(theta);
//	dy2 = d*sin(theta);
//
//	dx2 = CLAMP(dx2,-dx,dx);
//	dy2 = CLAMP(dy2,-dy,dy);
//	
//	d = sqrt(dx2*dx2 + dy2*dy2);
//    
//    //printf("d = %f dx2 = % f dy2 = % f\n",d,dx2,dy2);
//	
//	x1[0] = (x0[0]-ps[0])*cos(theta) + (x0[1]-ps[1])*sin(theta);
//	x1[1] = x0[2]*cos(theta) + x0[3]*sin(theta);
//    
//    //printf("x1 = % f % f\n",x1[0],x1[1]);    
//
//	if (x1[0] + x1[1]/w>=0)	dir = 1;
//	else					dir = -1;
//
//	for(tc[0] = 0.001;tc[0]<1.0;){
//		ddx = w2*(x1[0] - dir*d);
//
//		x1[0] += 0.001*0.5*(2*x1[1] + 0.001*ddx);
//		x1[1] += 0.001*ddx;
//
//		if (tc[0]>=t)		break;
//        
//        //printf("x1 = % f % f\n",x1[0],x1[1]); 
//
//		tc[0]+=0.001;
//	}
//
//	x[0] = x1[0]*cos(theta)+ps[0];
//	x[1] = x1[0]*sin(theta)+ps[1];
//	x[2] = x1[1]*cos(theta);
//	x[3] = x1[1]*sin(theta);
//
//}
//
//
//void find_step2(double *x0, double *ps, double L, double dx, double dy, double W, double *pc, double *tc, double *xc){	
//	double w = sqrt(9.81/L);
//	double w2 = w*w;
//	double ddx;
//	double x1[2];
//	double d,dx2,dy2;
//	int dir;
//	double step;
//	double theta = atan2(x0[1]-ps[1] + x0[3]/w,x0[0]-ps[0] + x0[2]/w);
//    
//    //printf("theta = % f\n",theta);
//
//	d = sqrt(dx*dx+dy*dy);
//
//	dx2 = d*cos(theta);
//	dy2 = d*sin(theta);
//
//	dx2 = CLAMP(dx2,-dx,dx);
//	dy2 = CLAMP(dy2,-dy,dy);
//	
//	d = sqrt(dx2*dx2 + dy2*dy2);
//    
//    //printf("d = %f dx2 = % f dy2 = % f\n",d,dx2,dy2);
//	
//	x1[0] = (x0[0]-ps[0])*cos(theta) + (x0[1]-ps[1])*sin(theta);
//	x1[1] = x0[2]*cos(theta) + x0[3]*sin(theta);
//
//	step = 0.5*(x1[0] + x1[1]/w);
//
//	pc[0] = ps[0] + step*cos(theta);
//	pc[1] = ps[1] + step*sin(theta);
//    
//    printf("x1 = % f % f\n",x1[0],x1[1]);    
//
//	if (x1[0] + x1[1]/w>=0)	dir = 1;
//	else					dir = -1;
//
//	printf("dir = %i\n",dir);
//
//	for(tc[0] = 0.001;tc[0]<1.0;){
//		ddx = w2*(x1[0] - dir*d);
//
//		x1[0] += 0.001*0.5*(2*x1[1] + 0.001*ddx);
//		x1[1] += 0.001*ddx;
//
//		if (dir*x1[0]>=dir*step)		break;
//        
//        //printf("x1 = % f % f\n",x1[0],x1[1]); 
//
//		tc[0]+=0.001;
//	}
//
//	//pc[0] = 2*x1[0]*cos(theta);
//	//pc[1] = 2*x1[0]*sin(theta);
//
//	xc[0] = x1[0]*cos(theta)+ps[0];
//	xc[1] = x1[0]*sin(theta)+ps[1];
//	xc[2] = x1[1]*cos(theta);
//	xc[3] = x1[1]*sin(theta);
//
//}
//    
//
//
//
//void find_step_state(double *x0, double *ps, double L, double dx, double dy, double W, double *pc, double time, double *x){
//	double t=0.0;
//	double ddx,ddy;
//	double dy1;
//    double w = sqrt(9.81/L);
//    double w2 = w*w;
//
//	x[0] = x0[0];
//	x[1] = x0[1];
//	x[2] = x0[2];
//	x[3] = x0[3];
//
//	for(t = 0.001;t<=time;t+=0.001){
//		ddx = w2*(x[0] - ps[0] - dx);
//		ddy = w2*(x[1] - ps[1] - dy);
//
//		x[0] += 0.001*0.5*(2*x[2] + 0.001*ddx);
//		x[1] += 0.001*0.5*(2*x[3] + 0.001*ddy);
//		x[2] += 0.001*ddx;
//		x[3] += 0.001*ddy;
//
//		if (x[2]<w*x[0])		break;
//	}
//
//	if (t>=time) return;
//
//	dy1 = x[3];
//
//	for(;t<=time;t+=0.001){
//		ddx = w2*(x[0] - pc[0]);
//		ddy = w2*(x[1] - pc[1]);
//
//		x[0] += 0.001*0.5*(2*x[2] + 0.001*ddx);
//		x[1] += 0.001*0.5*(2*x[3] + 0.001*ddy);
//		x[2] += 0.001*ddx;
//		x[3] += 0.001*ddy;
//
//		if (dy1*x[3]<0)		break;
//	}
//
//	if (t>=time) return;
//
//	for(;t<=time;t+=0.001){
//		ddx = w2*(x[0] - pc[0] - 0);
//		ddy = 0*w2*(x[1] - pc[1] + W/2 - 0);
//
//		x[0] += 0.001*0.5*(2*x[2] + 0.001*ddx);
//		x[1] += 0.001*0.5*(2*x[3] + 0.001*ddy);
//		x[2] += 0.001*ddx;
//		x[3] += 0.001*ddy;
//
//	}
//
//}
//
//void find_step(double *x0, double *ps, double L, double dx, double dy, double W, double *pc, double *x1, double *x2, double *t1, double *t2){	
//	double w = sqrt(9.81/L);
//	double w2 = w*w;
//	double ddx,ddy;
//	double dir;
//
//	if (x0[0] + x0[2]/w>=0)	dir = 1;
//	else					dir = -1;
//
//	//pc[0] = w2/dx*(x0[2]*x0[2]-w2*x0[0]*x0[0]);
//	//printf("% f\n",0.5/w2/d*dir*(x0[2]*x0[2]-w2*x0[0]*x0[0]));
//	
//	x1[0] = x0[0];
//	x1[1] = x0[1];
//	x1[2] = x0[2];
//	x1[3] = x0[3];
//	for(t1[0] = 0.001;t1[0]<1.0;){
//		ddx = w2*(x1[0] - ps[0] - dx);
//		ddy = w2*(x1[1] - ps[1] - dy);
//
//		x1[0] += 0.001*0.5*(2*x1[2] + 0.001*ddx);
//		x1[1] += 0.001*0.5*(2*x1[3] + 0.001*ddy);
//		x1[2] += 0.001*ddx;
//		x1[3] += 0.001*ddy;
//
//		if (x1[2]<w*x1[0])		break;
//
//		t1[0]+=0.001;
//	}
//    
//    pc[0] = 2*x1[0];
//
//	if (x1[1] + x1[3]/w>=0)	dir = 1;
//	else					dir = -1;
//
//	pc[1] = x1[1] + dir*sqrt(x1[1]*x1[1] - (x1[1]*x1[1]-x1[3]*x1[3]/w2 - W*W/4));
//
//	x2[0] = x1[0];
//	x2[1] = x1[1];
//	x2[2] = x1[2];
//	x2[3] = x1[3];
//	for(t2[0] = t1[0];t2[0]<2.0;){
//		ddx = w2*(x2[0] - pc[0] - 0*dx);
//		ddy = w2*(x2[1] - pc[1] - 0*dy);
//
//		x2[0] += 0.001*0.5*(2*x2[2] + 0.001*ddx);
//		x2[1] += 0.001*0.5*(2*x2[3] + 0.001*ddy);
//		x2[2] += 0.001*ddx;
//		x2[3] += 0.001*ddy;
//
//		if (x2[3]*x1[3]<0)		break;
//
//		t2[0]+=0.001;
//	}
//
//}



void update_weights(LiBMDyn_t *m, double *x){
    m->Wx = 0.5*(x[6]-x[4]);
    m->Wy = 0.5*(x[7]-x[5]);
    m->theta = atan2(m->Wx,-m->Wy);    
    m->x0 = 0.5*(x[4]+x[6]);
    m->y0 = 0.5*(x[5]+x[7]);
	m->W = 0.5*WIDTH(x);
	m->D = m->dsp_ratio*m->W;    
    
	m->x2 =  cos(m->theta)*(x[0]-m->x0) + sin(m->theta)*(x[1]-m->y0);
    m->y2 = -sin(m->theta)*(x[0]-m->x0) + cos(m->theta)*(x[1]-m->y0);
    
    m->dx2 = cos(m->theta)*(x[2]) + sin(m->theta)*(x[3]);
    m->dy2 =-sin(m->theta)*(x[2]) + cos(m->theta)*(x[3]);
    
	m->wL = CLAMP((m->D+m->y2)/2.0/m->D,0,1);
	m->wR = 1-m->wL;

	if (m->wL>0 && m->wL<1)
		m->dwL = m->dy2/2.0/m->D;
	else
		m->dwL = 0.0;

	m->dwR = -m->dwL;
}

void forward_dyn(LiBMDyn_t *m, double *x0, double *u, double *x1, double *f){
	/*	INPUT: 
			m - model
            x0 - 8x1 initial state [x,y,dx,dy,xL,yL,xR,yR]'
			u - 2x1 control [ux,uy]
		OUTPUT:		
            x1 - 8x1 final state
     *      f - force [flx,fly,flz,mlx,mly,mlz,frx,fry,frz,mrx,mry,mrz]'
	*/
	double ddx,ddy,mz;
    double uX,uY;
    
     uX = CLAMP(u[0],-m->mass*9.81*m->dx,m->mass*9.81*m->dx);
     uY = CLAMP(u[1],-m->mass*9.81*m->dy,m->mass*9.81*m->dy);
    
	ddx =   uX/m->mass/m->L - 9.81/m->L*(m->wL*(x0[4]-x0[0]) + m->wR*(x0[6]-x0[0]));
    ddy =   uY/m->mass/m->L - 9.81/m->L*(m->wL*(x0[5]-x0[1]) + m->wR*(x0[7]-x0[1]));

    x1[2] = x0[2] + m->dt*ddx;
    x1[3] = x0[3] + m->dt*ddy;    
    
	x1[0] = x0[0] + 0.5*m->dt*(x0[2]+x1[2]);
	x1[1] = x0[1] + 0.5*m->dt*(x0[3]+x1[3]); 
    
	x1[4] = x0[4];
	x1[5] = x0[5];
	x1[6] = x0[6];
	x1[7] = x0[7];
    
    //mz = ddx*m->mass*(m->wL*(x0[1]-x0[5]) + m->wR*(x0[1]-x0[7])) + ddy*m->mass*(m->wL*(x0[0]-x0[4]) + m->wR*(x0[0]-x0[6]));
	mz = m->wR*m->mass*(ddx*(x0[7]-x0[1]) - ddy*(x0[6]-x0[0])) + m->wL*m->mass*(ddx*(x0[5]-x0[1]) - ddy*(x0[4]-x0[0]));
    
    f[0] = m->wL*m->mass*ddx;
    f[1] = m->wL*m->mass*ddy;
    f[2] = m->wL*m->mass*9.81;
    f[3] = -m->wL*uY;
    f[4] = m->wL*uX;  
    f[5] = m->wL*mz;

    f[6] = m->wR*m->mass*ddx;
    f[7] = m->wR*m->mass*ddy;
    f[8] = m->wR*m->mass*9.81;
    f[9] = -m->wR*uY;
    f[10] = m->wR*uX;
    f[11] = m->wR*mz;
}

void integral_dyn(LiBMDyn_t *m, double x[8], double ddxdes[2], double Mdes[3], double u[3], double u2[3], double f[12]){
	//double Pc[2] = {x[0] - m->L/9.81*ddx[0],x[1] - m->L/9.81*ddx[1]};
	//double Pcdes[2] = ;
	

}

void inverse_dyn(LiBMDyn_t *m, double x[8], double ddx[2], double Mdes[3], double u[3], double f[12]){
	static int count;
	int i;
	double mz, ddx2[3],temp[3],temp2[3];

	double P[3],PR[3],PL[3],F2[3];

	P[0] = x[0];
	P[1] = x[1];
	P[2] = m->L;
	PL[0] = x[4];
	PL[1] = x[5];
	PL[2] = 0.0;
	PR[0] = x[6];
	PR[1] = x[7];
	PR[2] = 0.0;

	sdvsub(PR,P,PR);
	sdvsub(PL,P,PL);

	ddx2[0] = ddx[0];
	ddx2[1] = ddx[1];
	ddx2[2] = m->mass*9.81;

	sdvcross(PR,ddx2,temp);
	sdvmul(m->wR,temp,temp);
	sdvcross(PL,ddx2,temp2);
	sdvmul(m->wL,temp2,temp2);
	sdvadd(temp,temp2,temp);
	sdvsub(Mdes,temp,u);

	u[0] = CLAMP(u[0], -m->mass*9.81*m->dy, m->mass*9.81*m->dy);
	u[1] = CLAMP(u[1], -m->mass*9.81*m->dx, m->mass*9.81*m->dx);

   F2[0] = ( u[1] - m->mass*9.81*(m->wL*PL[0]+m->wR*PR[0]) - Mdes[1])*m->mass/m->L;
   F2[1] = (-u[0] - m->mass*9.81*(m->wL*PL[1]+m->wR*PR[1]) + Mdes[0])*m->mass/m->L;

   u[2] = F2[0]*(m->wL*PL[1]+m->wR*PR[1]) - F2[1]*(m->wL*PL[0]+m->wR*PR[0]) + Mdes[2];      
    
	//u[2]*=-1;

    f[0] = m->wL*F2[0];
    f[1] = m->wL*F2[1];
    f[2] = m->wL*m->mass*9.81;
    f[3] = m->wL*u[0];
    f[4] = m->wL*u[1];  
    f[5] = m->wL*u[2];

    f[6] = m->wR*F2[0];
    f[7] = m->wR*F2[1];
    f[8] = m->wR*m->mass*9.81;
    f[9] =  m->wR*u[0];
    f[10] = m->wR*u[1];
    f[11] = m->wR*u[2];

	count++;
}

void energy_control(LiBMDyn_t *m, double *x, double *u){
	double ddx_des[2]={0},E,a2,b2, Kx = 100, ddx2_des, ddy2_des;   
	double f[12];
	double Mdes[3]={0.0};
    
    ddx2_des = -Kx*m->x2 - 2*sqrt(Kx)*m->dx2;

	a2 = m->a*m->a;
	b2 = m->b*m->b;	
	E = 0.5*b2*m->dy2*m->dy2 + 0.5*a2*m->y2*m->y2;
	ddy2_des = -a2/b2*m->y2 + m->KE*(m->Ed-E)*m->dy2;

    ddx_des[0] =  cos(m->theta)*ddx2_des - sin(m->theta)*ddy2_des;
    ddx_des[1] =  sin(m->theta)*ddx2_des + cos(m->theta)*ddy2_des;
    
	inverse_dyn(m, x, ddx_des, Mdes, u, f);

}

// static void take_step(LiBMDyn_t *m, double *x, int state, double *step, int debug){
//     
// }


double simulate_onestep(LiBMDyn_t *m, double *x0, double *step_dist, int debug){
	int i;
	int state=DSP,zero_count=0,ssp_count=0;
	double cost = 0;
    double *x,*x1,*s,*s1,*u,*f;
    double y2,dy2;

    x = m->xtraj[m->traj_idx]; 
    s = m->straj[m->traj_idx];
    
    x[0] = x0[0];
    x[1] = x0[1];
    x[2] = x0[2];
    x[3] = x0[3]; 
    x[4] = x0[4];
    x[5] = x0[5];
    x[6] = x0[6];
    x[7] = x0[7];     
    
    update_weights(m, x);   

	if (m->y2>m->D){
        if(debug) printf("State = LSP\n");
		state = LSP;
		x[6] = x[6] + CLAMP(step_dist[0],-m->D,m->D);
		x[7] = x[7] + CLAMP(step_dist[1],-m->D,m->D);
		ssp_count++;
    }
	else if (m->y2<-m->D){
        if(debug) printf("State = RSP\n");
		state = RSP;
		x[4] = x[4] + CLAMP(step_dist[0],-m->D,m->D);
		x[5] = x[5] + CLAMP(step_dist[1],-m->D,m->D);
		ssp_count++;
    }else {       
        if(debug) printf("State = DSP\n");
    }
   
    update_weights(m, x); 
    y2 = m->y2;
    dy2 = m->dy2;
    
    s[0] = state;    

	for(i=m->traj_idx;i<MAXTRAJ-1;i++){
        
        x = m->xtraj[i];
        x1 = m->xtraj[i+1];
        s = m->straj[i];
        s1 = m->straj[i+1];
        u = m->utraj[i];
        f = m->ftraj[i]; 
        m->traj_idx=i+1; 
                
        update_weights(m, x);       

		energy_control(m, x, u);
        
		forward_dyn(m, x, u, x1, f);
        
        update_weights(m, x1);

		switch(state){
			case DSP:				
				if (m->y2>m->D && m->dy2>0){
                    x1[6] = x1[6] + step_dist[0];
                    x1[7] = x1[7] + CLAMP(step_dist[1],-m->D,m->D);
                    update_weights(m, x1);
					if(debug) printf("DSP->LSP\n");
					state = LSP;
					ssp_count++;
					break;
				}

				if (m->y2<-m->D && m->dy2<0){
                    x1[4] = x1[4] + step_dist[0];//CLAMP(step_dist[0],-m->D,m->D);
                    x1[5] = x1[5] + CLAMP(step_dist[1],-m->D,m->D);
                    update_weights(m, x1);
					if(debug) printf("DSP->RSP\n");
					state = RSP;
					ssp_count++;
					break;
				}

				break;
			case LSP:
				if (m->y2<m->D && m->dy2<0){
					if(debug) printf("LSP->DSP\n");
					state = DSP;
				}
				break;
			case RSP:
				if (m->y2>-m->D && m->dy2>0){
					if(debug) printf("RSP->DSP\n");
					state = DSP;
				}
				break;
		}		
        
        s1[0] = state;

 		cost += 1e3*m->dt*pow(0.5*m->b*m->b*m->dy2*m->dy2 + 0.5*m->a*m->a*m->y2*m->y2 - m->Ed,2.0); 
        
        cost += 0.0001*m->dt*(u[0]*u[0] + u[1]*u[1]);

		if (y2*m->y2<0){
			zero_count++;
            if(debug) printf("Crossing Zero\n");
			if (ssp_count>0 || zero_count>1){
				break;
			}
		}

		if (fabs(m->y2)>m->W+m->dx + fabs(m->x2)>m->W+m->dx){
            if(debug) printf("Crash!\n");
			cost = CRASH_COST;
			break;
		}
        
        y2 = m->y2;
        dy2 = m->dy2;

	}     
    if (debug) printf("%f %f\n",m->Wd,fabs(m->Wy));
	return cost + 0*(1e1*x[1]*x[1] + 1e3*pow(m->Wd-fabs(m->Wy),2.0));
}
  

static double get_nstep_cost(LiBMDyn_t *m, int N, double *step_set, int M, double *x0, int actionIdx, int step){
	double cost=0,lowest_cost=1.0e9,temp_cost;
	double next_state[8];
		
	m->traj_idx = 0;
	cost = simulate_onestep(m, x0, &step_set[2*actionIdx],0);
	//printf("%f\n",cost);
    
    //cost += 100*step_set[actionIdx]*step_set[actionIdx];

	next_state[0] = m->xtraj[m->traj_idx][0];
	next_state[1] = m->xtraj[m->traj_idx][1];
	next_state[2] = m->xtraj[m->traj_idx][2];
	next_state[3] = m->xtraj[m->traj_idx][3];
	next_state[4] = m->xtraj[m->traj_idx][4];
	next_state[5] = m->xtraj[m->traj_idx][5];
	next_state[6] = m->xtraj[m->traj_idx][6];
	next_state[7] = m->xtraj[m->traj_idx][7];    
	
	// don't bother if the simulation crashes
	if (cost==CRASH_COST) return cost;

	// recursive step
	if (step<N){
		int i;

		for (i=0;i<M;i++){
			m->traj_idx=0;
			temp_cost = get_nstep_cost( m, N, step_set, M, next_state, i, step + 1);
			if (temp_cost<lowest_cost){
                lowest_cost = temp_cost;
			}
		}
		return cost+lowest_cost;
	}
	else{
		cost += 1e4*next_state[1]*next_state[1] + 1e3*pow(m->Wd-fabs(m->Wy),2.0);
	}
	return cost;	
}

double lookahead(LiBMDyn_t *m, int N, double *step_set, int M, double *x0, double *best_action){
	
	int i;
	double lowest_cost=1.0e9, cost;
	
	for (i=0;i<M;i++){	
		m->traj_idx = 0;
		cost = get_nstep_cost( m, N, step_set, M, x0, i, 1);
		if (cost<lowest_cost){
			lowest_cost = cost;
			*best_action = (double)i;
		}
		//printf("%f %f %f %f\n",step_set[i],cost,lowest_cost,*best_action);
	}	

	return lowest_cost;
}