void subtract_v( double *v1, double *v2, double *v_out );
void cross_product( double *v1, double *v2, double *v_out );

void print_matrix( double r[3][3] );
void transpose( double m[3][3], double result[3][3] );
void multiply_m_v( double r[3][3], double *v_in, double *v_out );
void multiply_transpose_m_v( double r[3][3], double *v_in, double *v_out );
void multiply_matrices( double r1[3][3], double r2[3][3], double result[3][3] );
void invert( double m[3][3], double result[3][3] );
void R_x( double angle, double result[3][3] );
void R_y( double angle, double result[3][3] );
void R_z( double angle, double result[3][3] );
void R_axis_angle( double axis[3], double angle, double result[3][3] );

void invert_q( double *q_in, double *q_out );
double normalize_q( double *q_in, double *q_out );
void q_to_r( double *q, double r[3][3] );
void compose_q( double *q, double *p, double *result );
void q_to_rotvec( double *q, double *rotvec );
