clear all;clc;
files = {'push_file2','push_file3'};

for n=1:2
data = load(files{n});

data = data(1:2:end,:);


mag = sqrt(data(:,1).^2+data(:,2).^2);
dir = atan2(data(:,2),data(:,1));

data(:,1) = dir;
data(:,2) = mag;

% val = reshape(data(:,[1,4])',2,10,5);

largestpush(:,n) = zeros(10,1);

for i=1:10
    for j=1:5
        if (mag((j-1)*10+i)>largestpush(i,n) && data((j-1)*10+i,4)==1.0)
            largestpush(i,n) = mag((j-1)*10+i);
        end
    end
end
ang(:,n) = data(1:10,1);
% gooddata1 = data(data(:,4)==1 & data(:,3)==2.0,:);
% baddata1 = data(data(:,4)~=1 & data(:,3)==2.0,:);
% gooddata2 = data(data(:,4)==1 & data(:,3)==2.2,:);
% baddata2 = data(data(:,4)~=1 & data(:,3)==2.2,:);

end

LINEWIDTH = 2;

figure(1);clf;
polar(ang(:,1),largestpush(:,1),'bo-');
hold on;
polar(ang(:,2),largestpush(:,2),'rx-');
legend('With RHC','Without RHC');
set(gca,'FontSize',12);

%%
files = {'push_file4'};
clear ang;
clear largestpush;
for n=1:1
data = load(files{n});

data = data(1:end,:);


mag = sqrt(data(:,1).^2+data(:,2).^2);
dir = atan2(data(:,2),data(:,1));

data(:,1) = dir;
data(:,2) = mag;

% val = reshape(data(:,[1,4])',2,10,5);

largestpush(:,n) = zeros(12,1);

for i=1:12
    for j=1:5
        if (mag((j-1)*12+i)>largestpush(i,n) && data((j-1)*12+i,4)==1.0)
            largestpush(i,n) = mag((j-1)*12+i);
        end
    end
end
ang(:,n) = data(1:12,1);
% gooddata1 = data(data(:,4)==1 & data(:,3)==2.0,:);
% baddata1 = data(data(:,4)~=1 & data(:,3)==2.0,:);
% gooddata2 = data(data(:,4)==1 & data(:,3)==2.2,:);
% baddata2 = data(data(:,4)~=1 & data(:,3)==2.2,:);

end
polar(ang(:,1),largestpush(:,1),'g*-');
