clear all;
clc;
% mex preview_mex.cpp preview.cpp -DMATLAB -D_USE_BOOST -I"c:\boost"

L = 1.0;
T = 0.05;
N = 30;
Tstep = 0.4;
Tdsp = 0.1;
dx = 0.05;
dy = 0.05;

x0 = [0.0;0.2;0];
xf0 = 0;
y0 = [0;0.0;0];
yf0 = -0.12;
xs0 = 0.0;
ys0 = 0.12;

X = [x0;xf0;y0;yf0;xs0;ys0];
% for i=1:10
% [cost(i),step,traj] = preview_mex(X,L,T,N,0.025*i);
% end
% cost
[cost,step,traj] = preview_mex(X,L,T,N,Tstep,Tdsp);
figure(1);clf;
plot(traj(1:2,:)')

z = traj(1:2,:)' - L/9.81*traj(5:6,:)';

hold on;
plot(z,'--');

figure(2);clf;
px = traj(1,:)';
py = traj(2,:)';
zx = px - L/9.81*traj(5,:)';
zy = py - L/9.81*traj(6,:)';
xf = step(1);
yf = step(2);
plot(px,py,'g-'); hold on;
plot(zx,zy,'b-');
% plot(zxref,zyref,'k--');
legend('COM','ZMP','Location','Southeast');
plot(xf0,yf0,'g*');
plot(xf,yf,'g*');
plot(0.5*(xf0+xf),0.5*(yf0+yf),'go','LineWidth',3);
% plot([xf0;xf0+0.2*(x0(1)-xf0+x0(2)*sqrt(L/g))],[yf0;yf0+0.2*(y0(1)-yf0+y0(2)*sqrt(L/g))],'m-');

h = plot([xf0-dx,xf0+dx,xf0+dx,xf0-dx,xf0-dx]',[yf0-dy,yf0-dy,yf0+dy,yf0+dy,yf0-dy]','k-',...
         [xs0-dx,xs0+dx,xs0+dx,xs0-dx,xs0-dx]',[ys0-dy,ys0-dy,ys0+dy,ys0+dy,ys0-dy]','k--',...
         [xf-dx,xf+dx,xf+dx,xf-dx,xf-dx]',[yf-dy,yf-dy,yf+dy,yf+dy,yf-dy]','m-');
