#ifndef BEN_UTIL
#define BEN_UTIL

#include <gsl/gsl_matrix.h>

//-------- utility functions -------------------------------//
void gsl_matrix_vertcat(gsl_matrix *A, gsl_matrix *B, gsl_matrix *C);
void gsl_matrix_horzcat(gsl_matrix *A, gsl_matrix *B, gsl_matrix *C);
void gsl_pseudosolve_matrix(double *A, double *B, int trans, int m, int n, int r, double *X);
void gsl_pseudosolve_vector(double *A, double *b, int trans, int m, int n, double *x);

#endif